/*
 * task.h X68k SX_SYSTEM ver 2.01 Copyright 1994 SHARP/First Class Technology
 */
#ifndef __TASK_H
#define __TASK_H

#ifndef __SXDEF2_H
#include <sxdef2.h>
#endif

#ifdef FORWORD
#define __PROTO_TYPE
#endif
#ifdef __STDC__
#define __PROTO_TYPE
#endif

typedef enum TSEventCode TSEventCode;
typedef enum TaskState	TaskState;
typedef enum CMDSRscID	CMDSRscID;

typedef struct Task	Task;
typedef struct Builtin	Builtin;
typedef struct Cell	Cell;
typedef struct Drag	Drag;
typedef struct Scrap	Scrap;
typedef struct DrvInfo	DrvInfo;
typedef struct OpenFile	OpenFile;
typedef struct IcKind	IcKind;
typedef struct IcState	IcState;
/*
 *	^XN} (Task Man)
 */
#ifndef SXKERNEL
#define SXKERNEL	"sxkernel.x"
#endif
#ifndef SXVER2
#define SXVER2		0x0201
#endif
#define TS_OWN		(-1)
#define TS_FINISH	0
#define TS_PUTBACK	(-1)

enum TSEventCode {
	STARTUP,
	ENDTSK,
	CLOSEALL,
	NOTICEEJECT,
	DISKEJECT,
	NOTICEFORMAT,
	DISKFORMAT,
	NOTICEDCOPY,
	DISKCOPY,
	DISKINSERT,
	REMOVEDIR,
	DELETEFILE,
	DELETEVONAME,
	MOVEFILE,
	COPYFILE,
	MAKEDIR,
	CREATFILE,
	CREATEVONAME,
	OPENFILE	=  20,
	CLOSEFILE,
	CHMODFILE,
	CLOSEPATH	=  30,
	SAVE,
	WINDOWSELECT,
	NOTICEENDTSK,
	TOSCRAP		=  50,
	EMPTYTRASH,
	CREATETSK	=  70,
	EXITTSK,
	DRAGNOW		=  80,
	DRAGEND,
	SETFONT		=  85,
	CHANGEFONT,
	CHANGERSC	=  90,
	DELETERSC,
	REQLOADRSC	= 104,
	RESLOADRSC
};

enum TaskState {
	TS_EMPTY,
	TS_ACTIVE,
	TS_COMMUNICATE,
	TS_SENDMES,
	TS_SLEEP,
	TS_STARTUP,
	TS_LOAD,
	TS_EXIT
};

enum CMDSRscID {
	CMDSDIR,
	CMDSCHD,
	CMDSPINFO,
	CMDSDINFO,
	CMDSINFO,
	CMDSCLO,
	CMDSREN,
	CMDSCLIP,
	CMDSVDCP,
	CMDSVFOR,
	CMDSCOPY,
	CMDSCSHL,
	CMDSHENW,
	CMDSTITL,
	CMDSLDLB,
	CMDSADJS,
	CMDSFALL,
	CMDSFILE	/* 17 */
};

#define TS_RDONLY	1
#define TS_HIDDEN	(1 << 1)
#define TS_SYSTEM	(1 << 2)
#define TS_VOLID	(1 << 3)
#define TS_SUBDIR	(1 << 4)
#define TS_ARCH		(1 << 5)

#define TS_EJECT	(1 << 4)
#define TS_QUEST	(1 << 5)
#define TS_PROTECT	(1 << 6)

enum TSErrorCode {
	ER_ABORT	= -0x2002,
	ER_OBJX,
	ER_NOTHEAD,
	ER_NOTOBJECT,
	ER_NOTLOAD,
	ER_NOTPARA,
	ER_FILENOTFND	= -0x1fe1,
	ER_SERCHBREAK,
	ER_SERCHONEDRV,
	ER_DRVNOTREADY,
	ER_RSCROUTEERR	= -0x1fdb
};

struct Task {
	char name[TS_NAMEMAX];
	LASCII command;
	short taskID;
	short parentID;
	short stMode;
	long rscType;
	short rscID;
	short state;
	void *programPtr;
	Handle programHdl;
	Handle dataHdl;
	char *envPtr;
	long regKeep[18];
	short commSendID;
	short commRecvID;
	long tickCount;
	Handle commonHdl;
	long rsv1[3];
	long refCon;
	long rscChain;
	short rsv2[16];
};

struct Builtin {
	short rscID;
	char length;
	char name[_VARLEN];		/* ͉ϒf[^̐擪	*/
};

struct Cell {
	unsigned long kind;
	long size;
	unsigned char data[_VARLEN];	/* ͉ϒf[^̐擪	*/
};

struct Drag {
	long size;
	Handle cellList;
	short taskID;
	Point origen;
	BitImg *image;
};

struct Scrap {
	long size;
	Handle cellList;
};

struct DrvInfo {
	unsigned char mediaByte;
	unsigned char unitno;
	short driveno;
};

struct OpenFile {
	char name[TS_NAMEMAX];
	short mode;
	short ID;
};

struct IcKind {
	long type;
	short ID;
	short attrib;
	short mLDown;
	short menuID1;
	short menuID2;
	char nameLen;
	char name[_VARLEN];		/* name[] ͉ϒf[^	*/
/*	char execLen;
	char exec[_VARLEN];		   exec[] ϒf[^	*/
/*	unsigned char paramLen;
	char param[_VARLEN];		   param[] ϒf[^	*/
};

struct IcState {
	Rect bounds;
	char name[18 + 3];
	unsigned char attrib;
	long opt1;
	long opt2;
	unsigned char mediaByte;
	unsigned char unitno;
	short iconID;
	char *path;
	unsigned char flag;
	unsigned char drawMode;
	unsigned char rsv[4];
};

#ifdef __PROTO_TYPE

Heap *TSInitTsk(void *, void *, const char *, int, int, int, Handle *);
int TSInitCrtM(void);
int TSTiniCrtM(int);
int TSFock(int, int, char *, const char *, const char *, long, int);
int TSFockB(int, BOOLEAN, const char *, const char *, const char *, char *);
int TSFockSItem(Handle);
int TSFockIcon(IcState *, int, BOOLEAN, char *, char *);
int TSEventAvail(int, TsEvent *);
int TSGetEvent(int, TsEvent *);
int TSPostEventTsk(long, long, int, BOOLEAN, BOOLEAN);
int TSGetTdb(Task *, int);
int TSSetTdb(Task *, int);
LPoint TSGetWindowPos(void);
int TSCommunicate(int, TsEvent *, int);
int TSGetID(void);
int TSMakeEvent(long, long, int, BOOLEAN, BOOLEAN, TsEvent *);
BOOLEAN TSGetStartMode(void);
void TSSetStartMode(int);
int TSOpen(const char *, int);
int TSClose(int);
int TSRmDirH(char **);
int TSCopyH(char **, char **);
int TSMkDirH(char **);
int TSMoveH(char **, char **);
int TSCreate(const char *, int);
int TSDeleteH(char **);
int TSTrash(char **, char **);
int TSFiles(void *, const char *, int);
int TSNFiles(void *, const char *, int);
int TSCopyP(const char *, const char *);
int TSDeleteP(const char *);
int TSRmDirP(const char *);
int TSMkDirP(const char *);
int TSMoveP(const char *, const char *);
int TSChMod(const char *, int);
long TSWhatFile(TsEvent *, const char *);
int TSDeleteVoname(const char *);
int TSCreateVoname(const char *);
long TSSearchFileND(const char *, char *, const char *);
int TSGetOpen(OpenFile ***);
int TSZeroDrag(void);
int TSPutDrag(long, Handle);
int TSGetDrag(Drag **);
int TSBeginDrag(LPoint);
int TSEndDrag(int);
int TSHideDrag(void);
int TSShowDrag(void);
int TSZeroScrap(void);
int TSPutScrap(long, Handle);
long TSGetScrap(Scrap **);
int TSSearchTrashpath(char **);
int TSSearchTrashfile(char **);
int TSEmptyTrash(void);
int TSSearchdpb(int, int);
int TSDrvctrl(int, int);
int TSDrvctrl2(int, int);
int SXCallWindM(Window *, TsEvent *);
int SXCallCtrlM(Window *, TsEvent *, Control **, Control **, Rect *, Control ***);
int SXInvalScBar(Window *);
int SXValidScBar(Window *);
int TSISRecToStr(IcState *, char *);
int TSCreateISFile(char **, IcState *);
BOOLEAN SXFileConnPath(const char *, const char *);
int SXFileInPath(const char *, const char *);
int SXFnamecmp(const char *, int, const char *, int);
long SXSearchFname(const char *, char **);
int SXVer(void);
int TSTakeParam(const _LASCII, Rect *, char *, int, char **, char **);
long TSFindTskn(const char *, int);
int TSDriveCheckAll(BOOLEAN);
int TSDriveCheck(int);
int TSISRecToExec(IcState *, char *, _LASCII);
BOOLEAN TSGetDtopMode(void);
void TSSetDtopMode(BOOLEAN);
int TSSearchOpen(char **, int, int, OpenFile **);
long TSFindOwn(void);
int TSCommunicateS(int, TsEvent *, int);
long TSSearchFile2(int, int, void *, const char *, char *, const char *);
long TSSearchFile(const char *, char *, const char *);
int SXStrCmp(const char *, const char *, int);
int TSCreateISBadge(IcState *, int, int);
int TSGetCMDS(int, char *);
int TSFockCM(int, BOOLEAN, int, const char *, const char *, char *);
int TSTiniTsk(void);
int TSPostEventTsk2(long, long, int, BOOLEAN, BOOLEAN, int);
int TSAnswer(TsEvent *);
int TSSendMes(int, TsEvent *);
BOOLEAN TSGetMes(TsEvent *, BOOLEAN);
Heap *TSInitTsk2(void *, void *, const char *, int, BOOLEAN, int, char *, Handle *);
int SXCallWindM2(Window *, TsEvent *, Rect *);
int TSBeginDrag2(LPoint, void *, long);
void *SXGetVector(int);
void *SXSetVector(int, void *);
long TSCellToStr(Handle, char *, long, char ***);
void SXLockFSX(void);
void SXUnlockFSX(void);
int TSFockMode(const char *, char *, long *);
int TSSetGraphMode(BOOLEAN, int);
long TSGetGraphMode(long *);
int SXGetDispRect(Rect *);
int SXSRAMVer(void);
void SXSRAMReset(void);
int SXSRAMCheck(void);
void TSAdjustRect(Rect *, Rect *, int);
int TSPostEventTsk3(long, long, int, int, int, int, long, long);
int TSAnswer2(long, long, int, int, int, int, long, long);
int TSErrDialogN(int, const char *);
long TSSearchFile3(int, int, const char *, char *, const char *, int (*)(const char *, long));
Handle TSResNew(void);
Handle TSResOpen(const char *);
int TSResClose(const char *);
int TSResSave(const char *);
int TSResRemove(void);
int TSResLoad(void);
int TSResDispose(void);
Handle TSCurResGet(void);
Handle TSLastResGet(void);
Handle TSCurResSet(Handle);
_Handle TSRscAdd(long, int, _Handle, long);
_Handle TSRscGet(long, int);
int TSRscRemove(long, int);
int TSTypeRemove(long);
int TSRscRelease(_Handle);
int TSRscDetach(_Handle);
int TSMaxIDGet(long);
Handle TSHdlToRsc(_Handle);
Handle TSResLinkGet(Handle);
long TSResRouteLink(int, long);
long TSResRouteGet(int);
_Handle TSRscGet2(long, int, long);
_Handle TSRscGet3(long, int);
int TSResRouteUnLink(void);
int TSMaxIDGet2(long, long);
Handle TSFind(_Handle, long *, long *);
Handle TSCurResGet2(long);
int TSMaxIDGet3(long);
int TSResFileGet(Handle, char *);
long TSResRouteFind(const char *, int, long);
int TSResTypeList(int *, long ***, Handle);
int TSResIDList(int *, short ***, Handle, long);
void (*TSSetAbort(void (*)(), long))();
Window *TSReferWM(int, Window *, Window *);
Control **TSReferCM(int, Window *);
Menu **TSReferMN(int);
Dialog *TSReferDM(int, Dialog *, Window *);

#undef __PROTO_TYPE
#else

Heap *TSInitTsk();
int TSInitCrtM();
int TSTiniCrtM();
int TSFock();
int TSFockB();
int TSFockSItem();
int TSFockIcon();
int TSEventAvail();
int TSGetEvent();
int TSPostEventTsk();
int TSGetTdb();
int TSSetTdb();
LPoint TSGetWindowPos();
int TSCommunicate();
int TSGetID();
int TSMakeEvent();
BOOLEAN TSGetStartMode();
void TSSetStartMode();
int TSOpen();
int TSClose();
int TSRmDirH();
int TSCopyH();
int TSMkDirH();
int TSMoveH();
int TSCreate();
int TSDeleteH();
int TSTrash();
int TSFiles();
int TSNFiles();
int TSCopyP());
int TSDeleteP());
int TSRmDirP();
int TSMkDirP();
int TSMoveP();
int TSChMod();
long TSWhatFile();
int TSDeleteVoname();
int TSCreateVoname();
long TSSearchFileND();
int TSGetOpen();
int TSZeroDrag();
int TSPutDrag();
int TSGetDrag());
int TSBeginDrag();
int TSEndDrag();
int TSHideDrag();
int TSShowDrag();
int TSZeroScrap();
int TSPutScrap();
long TSGetScrap();
int TSSearchTrashpath();
int TSSearchTrashfile();
int TSEmptyTrash();
int TSSearchdpb();
int TSDrvctrl();
int TSDrvctrl2();
int SXCallWindM();
int SXCallCtrlM();
int SXInvalScBar();
int SXValidScBar();
int TSISRecToStr();
int TSCreateISFile();
BOOLEAN SXFileConnPath();
int SXFileInPath();
int SXFnamecmp();
long SXSearchFname());
int SXVer();
int TSTakeParam();
long TSFindTskn();
int TSDriveCheckAll();
int TSDriveCheck();
int TSISRecToExec();
BOOLEAN TSGetDtopMode();
void TSSetDtopMode();
int TSSearchOpen();
long TSFindOwn();
int TSCommunicateS();
long TSSearchFile2();
long TSSearchFile();
int SXStrCmp();
int TSCreateISBadge();
int TSGetCMDS();
int TSFockCM();
int TSTiniTsk();
int TSPostEventTsk2();
int TSAnswer();
int TSSendMes();
BOOLEAN TSGetMes();
Heap *TSInitTsk2();
int SXCallWindM2();
int TSBeginDrag2();
void *SXGetVector();
void *SXSetVector();
long TSCellToStr();
void SXLockFSX();
void SXUnlockFSX();
int TSFockMode();
int TSSetGraphMode();
long TSGetGraphMode();
int SXGetDispRect();
int SXSRAMVer();
void SXSRAMReset();
int SXSRAMCheck();
void TSAdjustRect();
int TSPostEventTsk3();
int TSAnswer2();
int TSErrDialogN();
long TSSearchFile3();
Handle TSResNew();
Handle TSResOpen();
int TSResClose();
int TSResSave();
int TSResRemove();
int TSResLoad();
int TSResDispose();
Handle TSCurResGet();
Handle TSLastResGet();
Handle TSCurResSet();
_Handle TSRscAdd();
_Handle TSRscGet();
int TSRscRemove();
int TSTypeRemove();
int TSRscRelease();
int TSRscDetach();
int TSMaxIDGet();
Handle TSHdlToRsc();
Handle TSResLinkGet();
long TSResRouteLink();
long TSResRouteGet();
_Handle TSRscGet2());
_Handle TSRscGet3();
int TSResRouteUnLink();
int TSMaxIDGet2();
Handle TSFind();
Handle TSCurResGet2();
int TSMaxIDGet3();
int TSResFileGet();
long TSResRouteFind();
int TSResTypeList();
int TSResIDList();
void (*TSSetAbort())();
Window *TSReferWM();
Control **TSReferCM();
Menu **TSReferMN();
Dialog *TSReferDM();

#endif __PROTO_TYPE

#endif __TASK_H
